/////////////////////////////////////////
//																		 //
//  Implementation of the Patron Class //
//																		 //
//					Chungho Chau							 //
//																		 //
/////////////////////////////////////////

#include <iostream.h>
#include <string.h>
#include "patron.h"

Patron &Patron::operator= (const char *other)
{
	return *this;
}


// Copy operator
Patron::Patron(const Patron &other)
{
	//	m_first_name(other.m_first_name); // doesn't work this way??

	m_first_name = other.m_first_name;
	m_last_name = other.m_last_name;	
	m_age = other.m_age;
}


// assignment operator
// this is not neccesary as it is enhanced in VString class
Patron &Patron::operator= (const Patron &other)
{
	if (this == &other)  // how about *this == other ??
		return *this;
  
	m_first_name = other.m_first_name;
	m_last_name  = other.m_last_name;
	m_age = other.m_age;
	return *this;
}


BOOL Patron::operator== (const Patron &other) const
{
	if ((m_first_name == other.m_first_name) && 
		  (m_last_name  == other.m_last_name) &&
		  (m_age				== other.m_age))
		return TRUE;
	else
		return FALSE;
}

void Patron::Display_All_Info(void) const
{
	cout << "\nFirst name is ";
  Display_First_Name();
	cout << "\nLast name is ";
	Display_Last_Name();
	cout << "\nAge is ";
	Display_Age();
	cout << '\n';
}

void Patron::Display_First_Name(void) const
{
	m_first_name.Display();
}


void Patron::Display_Last_Name(void) const
{
	m_last_name.Display();
}


void Patron::Display_Age(void) const
{
	cout << m_age;
}


void Patron::Change_First_Name(const char *first)
{
	m_first_name = first;
}


void Patron::Change_Last_Name(const char *last)
{
	m_last_name = last;
}


void Patron::Change_Age(const int age)
{
	m_age = age;
}


// Goble function implementation
ostream &operator<< (ostream &output, const Patron &other)
{
	output << "'" << other.m_first_name << ' ' << other.m_last_name 
				 << ' ' << other.m_age << "'";
	
	return output;
}