//////////////////////////////////////
// array.cpp temperaory						//
//																	//
//		//	
//																	//
//////////////////////////////////////

#include "array.h"

int Array::m_arrayCount=0;

Array::Array(int size)
{
	m_total = size;
	m_array = new char [m_total];
	m_location = 0;	
	m_arrayCount ++;
}

Array::~Array()
{
	delete [] m_array;
	m_arrayCount --;
}

Array::Array(const Array& other)
{
	m_array = new char [other.m_total];
	m_total = other.m_total;
	m_location = other.m_location;	

	for (int i=0; i<m_location; i++)
		m_array[i] = other.m_array[i];	

	m_arrayCount ++;
}
	

void Array::Add(char element)
{
	if (m_location == m_total)
		AddElement();

	m_array[m_location] = element;
	m_location ++;
}

void Array::Add(char* array, int size)
{
	if ( size<1 )
		return;

	while ( size > (m_total - m_location) )
		AddElement();

	for (int i=0; i< size; i++)
		m_array[i+m_location] = array[i];

	m_location += size;
}


void Array::AddElement(void)
{
	char* temp = new char [m_total];
	for (int i=0; i<m_location; i++)
		temp[i] = m_array[i];

	m_total += INCREMENT;	
	delete [] m_array;

	m_array = new char [m_total];

	for (i=0; i<m_location; i++)
		m_array[i] = temp[i];

	for (i=m_location; i<m_total; i++)
		m_array[i] = 0;

	delete [] temp;
}



Array &Array::operator= (const Array& other)
{
	if (this == &other)				// compare the pointer !!
	  return *this;		

	if (m_array)
		delete [] m_array;

	m_array = new char [other.m_total];
	m_total = other.m_total;
	m_location = other.m_location;

	for (int i=0; i<m_location; i++)
		m_array[i] = other.m_array[i];

	return *this;
}


BOOL Array::operator== (const Array& other)
{
	if (m_location != other.m_location)
		return FALSE;

	for (int i=0; i<m_location; i++)
	{
		if ( m_array[i] != other.m_array[i] )
			return FALSE;
	}

	return TRUE; 
}

char &Array::operator[] (int index)
{
	if ( (index<0) || (index>=m_location) )
		return m_array[0];
	else
		return m_array[index-1];
}



ostream &operator<< (ostream& output, const Array& other)
{
	if (other.m_location == 0)
		return output;

	output << '[';
	for (int i=0; i<other.m_location; i++)
	{
		output << other.m_array[i];
		if (i != other.m_location-1)
			output << ',';
	}

	output << ']';
	return output;
}

