//////////////////////////////////////
// Array Template Header File				//
//																	//
//	with Implementation ...					//
//																	//
//////////////////////////////////////

#ifndef TEMPLATE_CLASS
#define TEMPLATE_CLASS

#include "Generic.h"
#include <iostream.h>

class Array{
	friend ostream &operator<< (ostream& output, const Array& other);

	public:
		Array(int size=INCREMENT);
		~Array();

		Array(const Array& other);

		void Add(char element);
		void Add(char* array, int size);

		void AddElement(void);

		int GetSize(void) const {return m_location;}

		Array &operator= (const Array& other);

		BOOL operator== (const Array& other);

		BOOL operator!= (const Array& other)
			{ return !(*this == other); }

		char &operator[] (int index);

		static int GetArrayCount() {return m_arrayCount;}

	private:
		char* m_array;	  // pointer to first array element
		int		m_location;	// current location of empty spot
		int		m_total;		// total number of array element
		static int m_arrayCount;	// number of array instantiated
};

#endif